#ifndef __SFYGUIAPP_HPP
#define __SFYGUIAPP_HPP

#include <SophiaFramework.hpp>
#include "sfyguiapp.bid"

SFMTYPEDEFCLASS(sfyguiapp)
class sfyguiapp : public SFYApplication {
    SFMSEALCOPY(sfyguiapp)
private:
    SFZSoftKeyControlSmp _soft;                         // \tgL[
    SFZWindowSmp _window;                               // CEBhE
    SFYFrameSmp _frame;                                 // CEBhẼt[
public:
    static SFCInvokerPtr Factory(Void);
private:
    explicit sfyguiapp(Void) static_throws;
    virtual ~sfyguiapp(Void);
    SFCError Make(Void);
    SFZSoftKeyControlSmp MakeSoft(SFCErrorPtr exception, SFYResponderSmpConstRef parant);
    SFYFrameSmp MakeFrame(SFCErrorPtr exception, SFYResponderSmpConstRef parent, SFXRectangleConstRef rectangle);
    SFZWindowSmp MakeWindow(SFCErrorPtr exception, SFYFrameSmpConstRef parant);
    XANDLER_DECLARE_VOIDEVENT(OnTabSoft)
};

#endif // __SFYGUIAPP_HPP //
